import sqlite3

# DB Connect
def db_conn(db_file):
    con = None
    try:
        con=sqlite3.connect(db_file)
        return con
    except Error as e:
        print(e)

# Datenbankconfig
db="/home/frank_davids/Dokumente/flights.db" #database location
tb="flights"        #table name in database
# id=0, hex=1, reg=2, man=3, type=4, airline=5

def basic_clean():
    #Fehlermeldungen aus Registrierung löschen
    statement="SELECT * FROM " + tb + " WHERE registration LIKE '<!DOCTYPE%'"
    erg=c.execute(statement).fetchall()
    for i in erg:
        statement="UPDATE "+ tb + " SET registration='' WHERE icaohex='" + i[1] + "'"
        c.execute(statement)
        c.commit()
    #Registrierungen in Grossbuchstaben
    statement="SELECT * FROM " + tb + " WHERE UPPER(registration) != registration"
    erg=c.execute(statement).fetchall()
    for i in erg:
        if i[2] != "n/a2":
            reg=i[2].upper()
            statement="UPDATE " + tb + " SET registration='" + reg + "' WHERE icaohex='" + i[1] + "'"
            c.execute(statement)
            c.commit()
    #Felder die nur Striche haben leeren
    statement="SELECT * FROM " + tb + " WHERE registration LIKE '-%' OR type LIKE '-%' OR airline LIKE '-%'"
    erg=c.execute(statement).fetchall()
    for i in erg:
        if i[2].startswith("-"):
            reg="n/a2"
        else:
            reg=i[2]
        if i[4].startswith("-"):
            type=""
        else:
            type=i[4]
        if i[5].startswith("-"):
            airline=""
        else:
            airline=i[5]
        statement="UPDATE " + tb + " SET registration='" + reg + "', airline='" + airline + "', type='" + type + "' WHERE icaohex='" + i[1] + "'"
        c.execute(statement)
        c.commit()

def clean_man():
    #Hersteller aufräumen
    #Leere Hersteller auffüllen
    search=[
        ["a-22", "Aeroprakt", ""],
        ["wt9", "Aerospool", ""],
        ["sea", "AgustaWestland", ""],
        ["lynx", "AgustaWestland", ""],
        ["Airbus ", "Airbus", "cut"],
        ["a22", "Airbus", ""],
        ["a3", "Airbus", ""],
        ["kc-30", "Airbus", ""],
        ["ec-645", "Airbus Helicopters", "H145M"],
        ["ec645", "Airbus Helicopters", ""],
        ["ec-135", "Airbus Helicopters", ""],
        ["a40", "Airbus Military", ""],
        ["mbb", "Airbus Helicopters", ""],
        ["tiger", "Airbus Helicopters", ""],
        ["coug", "Airbus Helicopters", "H215M"],
        ["h145", "Airbus Helicopters", ""],
        ["pioneer", "Alpi Aviation", ""],
        ["American ", "American-General", "cut"],
        ["Antonov ", "Antonov", "cut"],
        ["an-", "Antonov", ""],
        ["Aquila ", "Aquila", "cut"],
        ["Aquila\t", "Aquila", "cut"],
        ["ATR ", "Avions de Transport Regional", ""],
        ["Avions de Transport Regional ", "Avions de Transport Regional", "cut"],
        ["Beech ", "Beech", "cut"],
        ["Beech+é-á", "Beech", "cut"],
        ["King", "Beech", ""],
        ["be20", "Beech", "B200 King Air"],
        ["bon", "Beech", ""],
        ["g3", "Beech", ""],
        ["Musket", "Beech", ""],
        ["Raytheon ", "Beech", "cut"],
        ["407", "Bell", ""],
        ["Blackwing ", "Blackwing", "cut"],
        ["Boeing ", "Boeing", "cut"],
        ["7_7", "Boeing", ""],
        ["p-8", "Boeing", ""],
        ["c-40", "Boeing", ""],
        ["challenger", "Bombardier", ""],
        ["glob", "Bombardier", ""],
        ["learjet 45", "Bombardier", ""],
        ["dhc-8", "Bombardier", ""],
        ["crj", "Bombardier", ""],
        ["Bombardier ", "Bombardier", "cut"],
        ["Canadair ", "Bombardier", "cut"],
        ["bae ", "British Aerospace", "cut"],
        ["atlan", "Breguet", ""],
        ["bris", "BRM", ""],
        ["bs", "Blackshape", ""],
        ["c42", "Comco Ikarus", ""],
        ["Cessna ", "Cessna", "cut"],
        ["Cessna\t", "Cessna", "cut"],
        ["Cit", "Cessna", ""],
        ["560", "Cessna", ""],
        ["Columbia Aircraft Mfg ", "Cessna", "cut"],
        ["Columbia ", "Cessna", "cut"],
        ["1_2", "Cessna", ""],
        ["Cirrus ", "Cirrus Design", "cut"],
        ["sr2", "Cirrus Design", ""],
        ["Commander 114", "Commander Aircraft", ""],
        ["tbm 940", "DAHER", ""],
        ["Dassault ", "Dassault", "cut"],
        ["falc", "Dassault", ""],
        ["Diamond Aircraft", "Diamond Aircraft", "Diamond Star"],
        ["Diamond", "Diamond Aircraft", ""],
        ["da62", "Diamond Aircraft", ""],
        ["da50", "Diamond Aircraft", ""],
        ["twin star", "Diamond Aircraft", ""],
        ["Dornier ", "Dornier", "cut"],
        ["ta-4", "Douglas", ""],
        ["mcr-", "Dyn Aero", ""],
        ["c295", "EADS CASA", ""],
        ["ea5", "Eclipse Aviation", ""],
        ["lega", "Embraer", ""],
        ["pheno", "Embraer", ""],
        ["Embraer ", "Embraer", "cut"],
        ["emb", "Embraer", ""],
        ["line", "Embraer", ""],
        ["erj", "Embraer", ""],
        ["praetor", "Embraer", ""],
        ["ea.3", "Extra", ""],
        ["ef", "Eurofighter", ""],
        ["typh", "Eurofighter", ""],
        ["Fokker ", "Fokker", "cut"],
        ["f-16", "General Dynamics", ""],
        ["g-2000", "Grobholz", ""],
        ["e-550", "Gulfstream Aerospace", ""],
        ["c-37", "Gulfstream Aerospace", ""],
        ["g2", "Gulfstream Aerospace", ""],
        ["g55", "Gulfstream Aerospace", ""],
        ["g65", "Gulfstream Aerospace", ""],
        ["gvii", "Gulfstream Aerospace", ""],
        ["giv", "Gulfstream Aerospace", ""],
        ["Gulfstream Aerospace ", "Gulfstream Aerospace", "cut"],
        ["uc-12w", "Hawker Beechcraft Corp", ""],
        ["hawker", "Hawker Beechcraft Corp", ""],
        ["125 8", "Hawker Beechcraft Corp", ""],
        ["honda", "Honda Aircraft Company", ""],
        ["lancair e", "Lancair International", ""],
        ["p-3", "Lockheed", ""],
        ["kc-130", "Lockheed", ""],
        ["c-130", "Lockheed", ""],
        ["mc-130", "Lockheed", ""],
        ["Maule ", "Maule", "cut"],
        ["McDonnell_Douglas ", "McDonnell Douglas", "cut"],
        ["dc-9", "McDonnell Douglas", ""],
        ["Mooney ", "Mooney", "cut"],
        ["m.20", "Mooney", ""],
        ["nh90", "NH Industries", ""],
        ["nh-90", "NH Industries", ""],
        ["t-28", "North American", ""],
        ["rq-4", "Northrop Grumman", ""],
        ["torn", "Panavia", ""],
        ["p-180", "Piaggio", ""],
        ["Pilatus ", "Pilatus", "cut"],
        ["pc-", "Pilatus", ""],
        ["Piper ", "Piper", "cut"],
        ["Piper\t", "Piper", "cut"],
        ["pa-", "Piper", ""],
        ["c-145", "PZL", ""],
        ["400 xp", "Raytheon Aircraft Company", ""],
        ["dr.400", "Robin", ""],
        ["Robinson ", "Robinson Helicopter", "cut"],
        ["r44", "Robinson Helicopter", ""],
        ["Saab ", "Saab", "cut"],
        ["340", "Saab", ""],
        ["ch-53", "Sikorsky", ""],
        ["Socata ", "Socata", "cut"],
        ["metro", "Swearingen", ""],
        ["p.20", "Tecnam", ""],
        ["c-160", "Transall", ""],
        ["Various", "Unknown", ""],
    ]
    for j in search:
        statement="SELECT * FROM " + tb + " WHERE manufacturer='' AND type LIKE '" + j[0] + "%'"
        erg=c.execute(statement).fetchall()
        for i in erg:
            man=j[1]
            if j[2]=="cut":
                type=i[4][len(j[0]):]
            elif j[2]=="":
                type=i[4]
            else:
                type=j[2]
            statement="UPDATE " + tb + " SET manufacturer='" + man + "', type='" + type + "' WHERE icaohex='" + i[1] + "'"
            c.execute(statement)
            c.commit()
    #Hersteller-Schreibweisen vereinheitlichen
    search=[
        ["euroc", "Airbus Helicopters", ""],
        ["text", "Cessna", ""],
    ]
    for j in search:
        statement="SELECT * FROM " + tb + " WHERE manufacturer LIKE '" + j[0] + "%'"
        erg=c.execute(statement).fetchall()
        for i in erg:
            if j[2]=="add":
                type=j[1]+i[4]
            elif j[2]=="rp":
                type=j[1]+i[4][len(j[0]):]
            else:
                type=j[1]
            statement="UPDATE " + tb + " SET manufacturer='" + type + "' WHERE icaohex='" + i[1] + "'"
            c.execute(statement)
            c.commit()

    #Hersteller zu Typ anpassen
    search=[
        ["Bombardier", "A220", "Airbus"],
        ["Lancair", "350", "Cessna"],
        ["Columbia", "400", "Cessna"],
    ]
    for j in search:
        statement="SELECT * FROM " + tb + " WHERE manufacturer LIKE '" + j[0] + "%' AND type LIKE '" +j[1] + "%'"
        erg=c.execute(statement).fetchall()
        for i in erg:
            man=j[2]
            statement="UPDATE " + tb + " SET manufacturer='" + man + "' WHERE icaohex='" + i[1] + "'"
            c.execute(statement)
            c.commit()
    #Typ-Schreibweisen vereinheitlichen
    search=[
        ["Aircraft Co\t", "Cessna", "cut"],
        ["Aquila ", "Aquila", "cut"],
        ["ag5b", "AG-5B Tiger", ""],
    ]
    for j in search:
        statement="SELECT * FROM " + tb + " WHERE type LIKE '" + j[0] + "%'"
        erg=c.execute(statement).fetchall()
        for i in erg:
            if j[2]=="cut":
                type=i[4][len(j[0]):]
            else:
                type=j[1]
            statement="UPDATE " + tb + " SET type='" + type + "' WHERE icaohex='" + i[1] + "'"
            c.execute(statement)
            c.commit()            

def clean_type():
    #Typ aufräumen
    #Typ Schreibweisen vereinheitlichen
    search=[
        ["c series ", "A220 ", "rp"],
        ["lynx", "Sea ", "add"],
        ["nh-90", "NH90-", "rp"],
        ["nh90 ", "NH90-", "rp"],
        ["nh90n", "NH90-N", "rp"],
    ]
    for j in search:
        statement="SELECT * FROM " + tb + " WHERE type LIKE '" + j[0] + "%'"
        erg=c.execute(statement).fetchall()
        for i in erg:
            if j[2]=="add":
                type=j[1]+i[4]
            elif j[2]=="rp":
                type=j[1]+i[4][len(j[0]):]
            else:
                type=j[2]
            statement="UPDATE " + tb + " SET type='" + type + "' WHERE icaohex='" + i[1] + "'"
            c.execute(statement)
            c.commit()

def clean_airline():
    #Airline aufräumen
    #Airline Schreibweisen vereinheitlichen
    search=[
        ["baf", "Belgian Air Component", ""],
        ["private owner", "Private", ""],
        ["civil", "Private", ""],
    ]
    for j in search:
        statement="SELECT * FROM " + tb + " WHERE airline LIKE '" + j[0] + "%'"
        erg=c.execute(statement).fetchall()
        for i in erg:
            if j[2]=="add":
                type=j[1]+i[4]
            elif j[2]=="rp":
                type=j[1]+i[4][len(j[0]):]
            else:
                type=j[1]
            statement="UPDATE " + tb + " SET airline='" + type + "' WHERE icaohex='" + i[1] + "'"
            c.execute(statement)
            c.commit()

c=db_conn(db)
c.cursor()

basic_clean()
clean_man()
clean_type()
clean_airline()

c.close()